﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace FSDSD_Client
{
    public class InputManager
    {// verwaltet input und leitet ihn an view/gui weiter
        KeyboardState KeyboardState; //Holds the state of the keyboard keys
        Keys[] ActPressedKeys;     //An array of the currently held down keys on the keyboard (newkeys)
        Keys[] OldPressedKeys;     //An array of the last time held down keys on the keyboard (pressedkeys)
        MouseState ActMouseState;   // aktueller zustand der maus
        MouseState OldMouseState;   // letzter Zustand der maus

        public bool bMouseMoved;
        private float fMousePosSeconds; // stores the seconds the mouse is hold over a position
        private GameTime lastTime;
        //# ADD letzte position wenn klick für den fall das drag gemacht wird,
        
        public InputManager()
        {// constructor
        }
        public void Init()
        {
            OldPressedKeys = (Keys[])KeyboardState.GetPressedKeys();
            OldMouseState = Mouse.GetState();
        }
        public void Update(GameTime gameTime)
        {// updates the input
            KeyboardState = Keyboard.GetState();
            OldPressedKeys = ActPressedKeys;    // remember the old pressed keys (act from last time)
            ActPressedKeys = (Keys[])KeyboardState.GetPressedKeys();  // get the new pressed keys

            OldMouseState = ActMouseState;  // remember old one
            ActMouseState = Mouse.GetState();   // query new one
            if ((ActMouseState.X == OldMouseState.X) && (ActMouseState.Y == OldMouseState.Y))
            {// check if mouse has been moved
                bMouseMoved = false;
                fMousePosSeconds = (float)(gameTime.TotalGameTime - lastTime.TotalGameTime).Milliseconds*0.0001f;
                //# TODO schauen ob fixed oder varialbe time step verwenden
            }
            else
            {
                bMouseMoved = true;
                fMousePosSeconds = 0.0f;
                lastTime = gameTime;
            }
        }
        public int GetScrolled()
        {// returns the scrolled value (0 if no scrolling happened)
            return ActMouseState.ScrollWheelValue - OldMouseState.ScrollWheelValue;
        }
        public int GetMousePosX()
        {// returns x mouse postion
            return ActMouseState.X;
        }
        public int GetMousePosY()
        {// returns y mouse position
            return ActMouseState.Y;
        }
        public bool IsPressed(Keys key)
        {// checks if the key is pressed (no matter if first time or not)
            if (ActPressedKeys != null)
            {// if there are any check which
                foreach (Keys keyact in ActPressedKeys)
                {// loop through all act pressed keys
                    if (keyact == key)
                    {
                        return true;
                    }
                }
            }
            return false;
        }
        public bool IsPressed(int button)   // 0 for left 1 for right mouse button
        {// checks if the button is pressed (no matter if first time or not)
            if (0 == button)
            {// check left button
                if (ButtonState.Pressed == ActMouseState.LeftButton)
                {
                    return true;
                }
            }
            else if (1 == button)
            {// check right button
                if (ButtonState.Pressed == ActMouseState.RightButton)
                {
                    return true;
                }
            }
            return false;   // the queried button is not pressed
        }
        public bool IsFirstPressed(Keys key)
        {// checks if the key is first pressed
            if (ActPressedKeys != null)
            {// if there are any check which
                foreach (Keys keyact in ActPressedKeys)
                {// loop through all act pressed keys
                    if (keyact == key)
                    {// the key is pressed this frame so check the previous one
                        foreach (Keys keyold in OldPressedKeys)
                        {// search it in the old pressed keys
                            if (key == keyold)
                            {// it was also pressed in previous frame so its not pressed the first time
                                return false;
                            }
                        }
                        return true;    // if i end here the key is pressed first time
                    }
                }
            }
            return false;   // no keys pressed at all
        }
        public bool IsFirstPressed(int button)
        {// checks if the button is first pressed
            if (0 == button)
            {// check left button
                if ((ButtonState.Pressed == ActMouseState.LeftButton) && (ButtonState.Pressed != OldMouseState.LeftButton))
                {
                    return true;
                }
            }
            else if (1 == button)
            {// check right button
                if ((ButtonState.Pressed == ActMouseState.RightButton) && (ButtonState.Pressed != OldMouseState.RightButton))
                {
                    return true;
                }
            }
            return false;
        }
        public bool IsHeld(Keys key)
        {// checks if the key is still beeing held
            if (ActPressedKeys != null)
            {// if there are any check which
                foreach (Keys keyact in ActPressedKeys)
                {// loop through all act pressed keys
                    if (keyact == key)
                    {// the key is pressed this frame so check the previous one
                        foreach (Keys keyold in OldPressedKeys)
                        {// search them each in the old pressed keys
                            if (keyact == keyold)
                            {
                                return true;
                            }
                        }
                        return false;   // not found key in both at same time
                    }
                }
            }
            return false;
        }
        public bool IsHeld(int button)
        {// checks if the button is still beeing held
            if (0 == button)
            {// check left button
                if ((ButtonState.Pressed == ActMouseState.LeftButton) && (ButtonState.Pressed == OldMouseState.LeftButton))
                {
                    return true;
                }
            }
            else if (1 == button)
            {// check right button
                if ((ButtonState.Pressed == ActMouseState.RightButton) && (ButtonState.Pressed == OldMouseState.RightButton))
                {
                    return true;
                }
            }
            return false;
        }
        public bool IsReleased(Keys key)
        {// checks if the key is released since last update call
            if (ActPressedKeys != null)
            {// if there are any check which
                foreach (Keys keyold in OldPressedKeys)
                {// loop through all old pressed keys 
                    if (keyold == key)
                    {// the key was pressed last frame so check the actual one
                        foreach (Keys keyact in ActPressedKeys)
                        {// search them each in the old pressed keys
                            if (keyact == keyold)
                            {
                                return false;   // still pressed
                            }
                        }
                        return true;    // not found in actual one so 
                    }
                }
            }
            return false;
        }
        public bool IsReleased(int button)
        {// checks if the button is released since last update call
            if (0 == button)
            {// check left button
                if ((ButtonState.Pressed != ActMouseState.LeftButton) && (ButtonState.Pressed == OldMouseState.LeftButton))
                {
                    return true;
                }
            }
            else if (1 == button)
            {// check right button
                if ((ButtonState.Pressed != ActMouseState.RightButton) && (ButtonState.Pressed == OldMouseState.RightButton))
                {
                    return true;
                }
            }
            return false;
        }
    }
}
