﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

[Serializable]

public class Station : FieldElement
{
    public int Ore; // die menge an erz die aktuell gelagert ist
    public int Supply;  // die Menge an life supply die aktuell gelagert ist
    public int CargoCapacity;
    public int RepairPrice;
    public int FuelPrice;
    public int SupplyMaxPrice;
    public int SupplyMinPrice;
    public int OreMaxPrice;
    public int OreMinPrice;


    public Station(float posx, float posy, float velx, float vely, float rotang, float rotspd, int type, int count, bool dockable, int cargcap, int repprice, int fuelprice, int supmaxprice, int supminprice, int oremaxprice, int oreminprice) : base(posx, posy, velx, vely, rotang, rotspd, type, count, dockable)
    {
        CargoCapacity = cargcap;
        Supply = CargoCapacity / 3; // ein drittel voll supply starten, wenn ganz voll kein platz um gleich was zu verkaufen
        Ore = CargoCapacity / 3; // ein drittel voll erz starten sonst nix zu kaufen zu beginn
        RepairPrice = repprice;
        FuelPrice = fuelprice;
        SupplyMaxPrice = supmaxprice;
        SupplyMinPrice = supminprice;
        OreMaxPrice = oremaxprice;
        OreMinPrice = oreminprice;
    }
    public Station(Station orig):base(orig.Position_X,orig.Position_Y,orig.Velocity_X,orig.Velocity_Y,orig.RotationAngle,orig.RotationSpeed,orig.Type,orig.Count,orig.Dockable)
    {// copy constructor
        this.Ore = orig.Ore;
        this.Supply = orig.Supply;
        this.CargoCapacity = orig.CargoCapacity;
        this.RepairPrice = orig.RepairPrice;
        this.FuelPrice = orig.FuelPrice;
        this.SupplyMaxPrice = orig.SupplyMaxPrice;
        this.SupplyMinPrice = orig.SupplyMinPrice;
        this.OreMaxPrice = orig.OreMaxPrice;
        this.OreMinPrice = orig.OreMinPrice;
    }
    public int GetOrePrice()
    {// gibt den erzpreis in abhängigkeit von der vorhandenen menge zurück
        return (OreMaxPrice-OreMinPrice)*Ore/CargoCapacity+OreMinPrice;
    }
    public int GetSupplyPrice()
    {// gibt den supplypreis in abhängigkeit von der vorhandenen menge zurück
        return (SupplyMaxPrice - SupplyMinPrice) * Supply / CargoCapacity + SupplyMinPrice;
    }
    public int GetRepairPrice()
    {// was die Reparatur eine Einheit Panzerung kostet
        return RepairPrice;
    }
    public int GetFuelPrice()
    {// was das auffüllen einer einheit treibstoff kostet
        return FuelPrice;
    }
}

