﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

[Serializable]

public class Universe
{// das spielfeld mit allen entitäte darin
    public List<FieldElement> Elements;    // alle elemente des spielfelds

    public int NumberofAsteroids;   // anzahl der asteroiden
    public int NumberofStations;    // anzahl der stationen
    public int NumberofFreighters;  // anzahl der frachter
    public int Radius;  // der radius des kreisförmigen spielfeldes in pixel
    public int StationProductionRate;  // Förderrate der Stationen pro Minute
    public int StationSupplyUsageRate;  // verbrauch an supply jeder station pro minute
    public int StationCargoHold;    // der Laderaum (Kapazität) der Stationen
    public int StationSellsUpgrades;  // stationen verkaufen upgrades
    public int StationRepairs;  // stationen reparieren schiff
    public int StationRefuels;  // stationen betanken schiff
    public int FreighterSellsUpgrades;  // frachter verkaufen upgrades
    public int FreighterRepairs;  // frachter reparieren schiff
    public int FreighterRefuels;  // frachter betanken schiff
    public int FuelCost;        // kosten für eine einheit treibsotff
    public int RepairCost;      // kosten für die reparatur einer einheit Panzerung
    public int NumberofPlayers;     // anzahl der spieler gesamt (rest wird durch ki gesteuert)
    public int GameDuration;    // dauer des spiels in minuten
    public int UpgradeCostFactor;   // faktor mit dem die Kosten des nächsten Upgrades aus den Kosten der aktuellen Stufe ausgerechnet werden
    public int UpgradeCostBase;     // kosten des ersten upgrades
    public float FuelUsage;           // verbrauch an treibstoff pro Sekunde und beschleunigung 1
    public int MaxAsteroidVelocity; // höchstgeschwindigkeit der asteroiden entlang einer achse (bei 45° dazu das 1,4 fache möglich)
    public int FuelAmount;  // die Menge an Treibstoff die ein Schiff mit sich führen kann
    public bool GamePaused; // ob das spiel pausiert ist
    public TimeSpan TimeToRun;  // die zeit die das spiel noch läuft
    public int MaxHitpoints;   // maximalstärke der panzerung um schäden bei kollisionen zu absorbieren (durch upgrades und config beeinflusst)
    public int MaxPlayerCargo;     // der laderaum der raumschiffe (durch upgrades und config beeinflusst)
    public int MaxUpgradeLevel; // so viele Upgrades können maximal gekauft werden
    public int MaxMessages; // so viele nachrichten speichert der spieler
    public int SupplyMaxPrice;
    public int SupplyMinPrice;
    public int OreMaxPrice;
    public int OreMinPrice;
    public int PriceBonus;
    public int StartMoney;  // mit diesem betrag beginnt jeder spieler

    public Universe()
    {// konstruktor um das universum zu initialisieren (daten werden aber später vom serverinterface reingefüllt)
        Elements = new List<FieldElement>();
    }

    public void MakeCopy(Universe original)
    {// kopiert die daten vom original
        int i;
        if (original.Elements.Count > this.Elements.Count)
        {// das zweite array ist noch nicht initialisiert also die elemente einfügen
            for (i = 0; i < original.Elements.Count; i++)
            {
                this.Elements.Add(original.Elements[i]);
            }
        }
        for (i = 0; i < original.Elements.Count; i++)
        {// alle elemente kopieren
            this.Elements[i] = original.Elements[i];
        }
        this.NumberofAsteroids = original.NumberofAsteroids;
        this.NumberofStations = original.NumberofStations;
        this.NumberofFreighters = original.NumberofFreighters;
        this.Radius = original.Radius;
        this.StationProductionRate = original.StationProductionRate;
        this.StationSupplyUsageRate = original.StationSupplyUsageRate;
        this.StationCargoHold = original.StationCargoHold;
        this.StationSellsUpgrades = original.StationSellsUpgrades;
        this.StationRepairs = original.StationRepairs;
        this.StationRefuels = original.StationRefuels;
        this.FreighterSellsUpgrades = original.FreighterSellsUpgrades;
        this.FreighterRepairs = original.FreighterRepairs;
        this.FreighterRefuels = original.FreighterRefuels;
        this.FuelCost = original.FuelCost;
        this.RepairCost = original.RepairCost;
        this.NumberofPlayers = original.NumberofPlayers;
        this.GameDuration = original.GameDuration;
        this.UpgradeCostFactor = original.UpgradeCostFactor;
        this.UpgradeCostBase = original.UpgradeCostBase;
        this.FuelUsage = original.FuelUsage;
        this.MaxAsteroidVelocity = original.MaxAsteroidVelocity;
        this.GamePaused = original.GamePaused;
        this.TimeToRun = original.TimeToRun;
        this.MaxHitpoints = original.MaxHitpoints;
        this.MaxPlayerCargo = original.MaxPlayerCargo;
        this.MaxUpgradeLevel = original.MaxUpgradeLevel;
        this.MaxMessages = original.MaxMessages;
        this.SupplyMaxPrice = original.SupplyMaxPrice;
        this.SupplyMinPrice = original.SupplyMinPrice;
        this.OreMaxPrice = original.OreMaxPrice;
        this.OreMinPrice = original.OreMinPrice;
        this.PriceBonus = original.PriceBonus;
        this.StartMoney = original.StartMoney;
    }
}

